# Copyright (C) 2009-2010 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

from tg import flash, request, require, redirect, tmpl_context, app_globals, validate
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from repoze.what.predicates import not_anonymous

from luci.lib.base import expose, BaseController

__all__ = ['AsyncController']

class AsyncController(BaseController):
    allow_only = not_anonymous()

    @expose("json")
    def get_cluster_nodes(self, **kw):
        from luci.lib.async_helpers import get_node_list

        host = kw.get('host')
        if not host:
            return { 'errors': [ _('No host was given') ] }

        port = kw.get('port')
        if not port:
            return { 'errors': [ _('No port was given for host "%s"') % host ] }
        try:
            port = int(port)
            if port != port & 0xffff:
                raise ValueError, port
        except ValueError:
            return { 'errors': [ _('An invalid port "%s" was given for host "%s"') % (kw.get('port'), host) ] }

        passwd = kw.get('passwd')
        if not passwd:
            return { 'errors': [ _('No password was given for host "%s"') % host ] }
        return get_node_list(host, port, passwd)

    @expose("json")
    def is_cluster_busy(self, **kw):
        from luci.lib.db_helpers import get_cluster_task_status
        cluster_name = kw.get('cluster')
        if not cluster_name:
            return {'busy': False, 'errors': _('No cluster name was given') }
        ret = get_cluster_task_status(cluster_name)
        ret[1]['busy'] = ret[0]
        return ret[1]
